#include <ecf/ECF.h>
#include "GPcacheEvalOp.h"
#include <math.h>
#include <time.h>


FitnessP GPcacheEvalOp :: evaluate(IndividualP individual){

  FitnessP fitness = static_cast<FitnessP> (new FitnessMin);
 
  TreeP tree = boost::dynamic_pointer_cast<Tree::Tree> 
	  (individual->getGenotype());

  int br_promasaja =0 , memorija[VEL_CASHA]={0} 
  , polje[MAXPOLJE], i, j, k, temp[5]={1,2,3,5,7};


	  for (i=0 ; i<MAXPOLJE ; i++){      //pocetak inicijalizacije slucajnog polja

		polje[i]= ((rand())%BR_STR)+1 ;
		j=((rand())%KOEF_JEDNOG);

		if (i+j<MAXPOLJE) {
			for (k=1; k<=j; k++){
				polje[i+k]=((polje[i+k-1])%BR_STR)+1;
			}
			i+=j ;
		}else{
			polje[i]= ((rand())%BR_STR)+1 ;
		}
	} //kraj inicijalizacije slucajnog polja

	  double zamjena=0 , predhodno=0 ;
	  
      bool flag ;

	  for ( i=0 ; i<MAXPOLJE ; i++ ){
	  
		  flag=false ;
		  for( j=0 ; j<VEL_CASHA ; j++ ){
		  
			  if(polje[i]==memorija[j])  {
				flag=true ;
				predhodno=(double)j;
				break ;
			  }
		  }
	  
		  if(flag) continue ;                //  provjera dali netreba nista mjenjat
		  br_promasaja++;

		  tree->setTerminalValue("X1", &temp[0]);
		  tree->setTerminalValue("X2", &temp[1]);
		  tree->setTerminalValue("X3", &temp[2]);
		  tree->setTerminalValue("X5", &temp[3]);
		  tree->setTerminalValue("X7", &temp[4]);
		  tree->execute(&zamjena);
		  zamjena=((int)(predhodno+(fabs(zamjena))))%VEL_CASHA ;

		 
		  memorija[(int)zamjena]=polje[i] ;
		  predhodno=zamjena ;
		  

	    }


	  fitness->setValue(br_promasaja);

	  return fitness ;

}