#include <iostream>
#include <string>
#include <cstdlib>
#include <ctime>

#define MAXPOLJE 1000
#define VEL_CASHA 10
#define BR_STR 100
#define KOEF_JEDNOG 5


using namespace std ;



int fifo( int *ulaz ) ;
int lru( int *ulaz ) ;
int pagenator_20( int *ulaz );


int main() {

	int polje[MAXPOLJE] , i , j , k ,g , br_promasaja_fifo=0 
		, br_promasaja_lru=0 , br_promasaja_pagenator_20=0 , best_of_fifo=1000
		, best_of_lru=1000 , best_of_pagenator_20=1000 , pom1 ; 
	float avg_fifo , avg_lru , avg_pagenator_20;

	srand(unsigned(time(0)));

	for(g=0 ; g<1000 ; g++){
		for (i=0 ; i<MAXPOLJE ; i++){

		
			polje[i]= ((rand())%BR_STR)+1 ;
			j=((rand())%KOEF_JEDNOG);
			if (i+j<MAXPOLJE) {
				for (k=1; k<=j; k++){
					polje[i+k]=((polje[i+k-1])%BR_STR)+1;
				}
				i+=j ;
			}else{
				polje[i]= ((rand())%BR_STR)+1 ;
			}

	}

	pom1 = fifo ( &polje[0] );
	if(pom1<best_of_fifo) {
		best_of_fifo=pom1;
	}
	br_promasaja_fifo += pom1;

	pom1 = lru ( &polje[0] );
	if(pom1<best_of_lru) {
		best_of_lru=pom1;
	}
	br_promasaja_lru += pom1;

	pom1 = pagenator_20 ( &polje[0] );
	if(pom1<best_of_pagenator_20) {
		best_of_pagenator_20=pom1;
	}
	br_promasaja_pagenator_20 += pom1;

	}
	avg_fifo=(float)br_promasaja_fifo/g;
	avg_lru=(float)br_promasaja_lru/g;
	avg_pagenator_20=(float)br_promasaja_pagenator_20/g;

	cout<<"\n\nprosjecan broj promasaja \nFIFO = "<<avg_fifo<<"\nLRU = "<<avg_lru
		<<"\npagenator_20 = "<<avg_pagenator_20<<"\n";
	
	cout<<"\n\nnajmanji broj promasaja \nFIFO = "<<best_of_fifo<<"\nLRU = "<<best_of_lru
		<<"\npagenator_20 = "<<best_of_pagenator_20<<"\n";





	system("PAUSE");

	return 0 ;
}


int fifo( int ulaz[MAXPOLJE] ) {

	int broj_promasaja=0 , trenutno[VEL_CASHA]={0}, i , sljed=0 , j , k , pom;

	for ( i=0 ; i<MAXPOLJE ; i++ ){
	
		for (j=0 ; j<VEL_CASHA ; j++ ){
			
			pom=0;

			for (k=0 ; k<VEL_CASHA ; k++){
				if(ulaz[i]==trenutno[k]){
					pom=1;
					break ;
				}
			}

			if (pom) break ; 

			if(trenutno[sljed]==0 ) {
				broj_promasaja++;
				trenutno[sljed]=ulaz[i];
				sljed=((sljed+1)%VEL_CASHA);
				break ;
			}
			
			broj_promasaja++ ;
			trenutno[sljed]=ulaz[i];
			sljed=((sljed+1)%VEL_CASHA);
			break ;

		}
	}

	cout<<"\nbroj promasaja algoritma FIFO je " <<broj_promasaja 
		<< " od " << MAXPOLJE <<'\n' ;

	return broj_promasaja ;
}

int lru( int *ulaz ) {

	int broj_promasaja=0 , i , prije_koliko[VEL_CASHA] , trenutno[VEL_CASHA]={0} 
		, j , max , k , g , index , flag ;



	for(k=0;k<VEL_CASHA;k++){         //povecaj indekse svih da budu veci od 0
	prije_koliko[k]=VEL_CASHA*2;
	}

	for ( i=0 ; i<MAXPOLJE ; i++ ){
	

		for (j=0 ; j<VEL_CASHA ; j++ ){
						
			flag=0;

			for(k=0 ; k<VEL_CASHA ; k++){
			
				if(*(ulaz+i)==trenutno[k]){
					prije_koliko[k]=0;
					flag=1 ;

				for(g=0;g<VEL_CASHA;g++){         //povecaj indekse svih
					prije_koliko[g]+=1;
				}
				break ;
				}
			}

			if (flag) break ;

			max=prije_koliko[0] ;
			index=0;
			for (k=1 ; k<VEL_CASHA ; k++){
				
				if( prije_koliko[k] > max ){
					max=prije_koliko[k];
					index=k;
				}
			}
			
			broj_promasaja++;
			prije_koliko[index]=0 ;
			trenutno[index]=*(ulaz+i) ;
			
			for(g=0;g<VEL_CASHA;g++){         //povecaj indekse svih
			prije_koliko[g]+=1;
			}

			break ;
		}	

	}	
	cout<<"\nbroj promasaja algoritma LRU je " <<broj_promasaja 
		<< " od " << MAXPOLJE <<'\n' ;
	return broj_promasaja ;
}

int pagenator_20( int *ulaz ){

	int br_promasaja=0 , memorija[VEL_CASHA]={0} , i , j , trenutno=0 , flag=0;


	for(i=0 ; i<MAXPOLJE ; i++){
	
		flag=0;
		for(j=0; j<VEL_CASHA ; j++){
			if(*(ulaz+i)==memorija[j]) {
				trenutno=j;
				flag=1;
				break;
			}
			
		}


	if(flag) continue ;
	br_promasaja++;
	
	trenutno=(trenutno+7)%VEL_CASHA;
	memorija[trenutno]=*(ulaz+i);

	
	}
	cout<<"\nbroj promasaja algoritma pagenator_20 je " <<br_promasaja 
	<< " od " << MAXPOLJE <<'\n' ;

	return br_promasaja ;
}

